VERSION 5.00
Begin VB.UserControl NumericEdit 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   ToolboxBitmap   =   "NumericEdit.ctx":0000
   Begin VB.TextBox txtValue 
      Height          =   375
      Left            =   0
      TabIndex        =   0
      Text            =   "0"
      Top             =   0
      Width           =   1575
   End
End
Attribute VB_Name = "NumericEdit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Const badBackColor As Long = &H8080FF

Private m_MinValue As Integer
Private m_MaxValue As Integer
Private m_CheckInterval As Boolean
Private m_DecimalChar As String
Private m_DisplayMessageBox As Boolean

Private Sub txtValue_Change()
    txtValue.BackColor = vbWhite
End Sub

Private Sub txtValue_KeyPress(KeyAscii As Integer)
    If KeyAscii = 8 Or Chr(KeyAscii) = m_DecimalChar Then
        Exit Sub
    End If
    
    If Chr(KeyAscii) < "0" Or Chr(KeyAscii) > "9" Then
        KeyAscii = 0
        Beep
    End If
End Sub

Private Sub txtValue_LostFocus()
    
    If m_CheckInterval Then
        If m_MaxValue < m_MinValue Then
            If m_DisplayMessageBox Then
                MsgBox "MaxValue must be greater than MinValue"
            End If
            txtValue.BackColor = badBackColor
            Exit Sub
        End If
    
        If Not IsNumeric(txtValue.Text) Then
            If m_DisplayMessageBox Then
                MsgBox "Please enter a numeric value"
            End If
            txtValue.BackColor = badBackColor
            Exit Sub
        End If
        
        Dim value As Integer
        value = CDbl(txtValue.Text)
        If value < m_MinValue Or value > m_MaxValue Then
            If m_DisplayMessageBox Then
                MsgBox "Please enter a value in [" & _
                       m_MinValue & ".." & _
                       m_MaxValue & "]"
            End If
            txtValue.BackColor = badBackColor
            Exit Sub
        End If
    End If
End Sub

Private Sub UserControl_Resize()
    txtValue.Width = Width
    txtValue.Height = Height
End Sub

'-Doit-on afficher des botes de dialogues d'erreurs ?--
Public Property Get DisplayMessageBox() As Boolean
    DisplayMessageBox = m_DisplayMessageBox
End Property

Public Property Let DisplayMessageBox(value As Boolean)
    m_DisplayMessageBox = value
End Property

'-Symbole dcimal---------------------------------------
Public Property Get DecimalChar() As String
    DecimalChar = m_DecimalChar
End Property

Public Property Let DecimalChar(value As String)
    If Len(value) > 1 Then
        If m_DisplayMessageBox Then
            MsgBox "Un caractre au maximum", vbExclamation
        End If
        value = Left(value, 1)
    End If
    
    m_DecimalChar = value
End Property

'-Gestion de la valeur du contrle----------------------
Public Property Get value() As String
    value = txtValue.Text
End Property
   
Public Property Let value(theValue As String)
    txtValue.Text = theValue
End Property

'-Gestion de la valeur minimale-------------------------
Public Property Get MinValue() As Integer
    MinValue = m_MinValue
End Property

Public Property Let MinValue(value As Integer)
    m_MinValue = value
End Property

'-Gestion de la valeur maximale-------------------------
Public Property Get MaxValue() As Integer
    MaxValue = m_MaxValue
End Property

Public Property Let MaxValue(value As Integer)
    m_MaxValue = value
End Property

'-Doit on vrifier l'interval---------------------------
Public Property Get CheckInterval() As Boolean
    CheckInterval = m_CheckInterval
End Property

Public Property Let CheckInterval(value As Boolean)
    m_CheckInterval = value
End Property

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    txtValue.Text = PropBag.ReadProperty("Value", 0)
    m_MinValue = PropBag.ReadProperty("MinValue", 0)
    m_MaxValue = PropBag.ReadProperty("MaxValue", 0)
    m_CheckInterval = PropBag.ReadProperty("CheckInterval", False)
    m_DecimalChar = PropBag.ReadProperty("DecimalChar", ",")
    m_DisplayMessageBox = PropBag.ReadProperty("DisplayMessageBox", True)
End Sub


Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "Value", txtValue.Text, 0
    PropBag.WriteProperty "MinValue", m_MinValue, 0
    PropBag.WriteProperty "MaxValue", m_MaxValue, 0
    PropBag.WriteProperty "CheckInterval", m_CheckInterval, False
    PropBag.WriteProperty "DecimalChar", m_DecimalChar, ","
    PropBag.WriteProperty "DisplayMessageBox", m_DisplayMessageBox, True
End Sub
